* $$ JOB JNM=CAFCICS1,CLASS=0,DISP=D                                    00001000
* $$ LST CLASS=A,DISP=D,JSEP=0,DEST=(,LEO)                              00002000
* $$ PUN CLASS=0,DISP=I,JSEP=0                                          00003000
// JOB CAFCICS1                                                         00004000
// OPTION LOG,DECK,NOSYSDUMP                                            00005000
// LIBDEF *,SEARCH=(PRD2.TCPIP,BIMLIB.TCPIP15D,                        C00006000
               PRD1.MACLIB,PRD2.SCEECICS,PRD2.SCEEBASE,                C00007000
               PRD1.BASE)                                               00008000
// LIBDEF *,CATALOG=PRD2.TCPIP                                          00009000
// EXEC ASSEMBLY                                                        00010000
         PUNCH    '* $$ JOB JNM=CAFCICS1,CLASS=0,DISP=D'                00011000
         PUNCH    '* $$ LST CLASS=A,DISP=D,DEST=(,LEO)'                 00012000
         PUNCH    '// JOB CAFCICS1'                                     00013000
         PUNCH    '// EXEC LIBR'                                        00014000
         PUNCH    'ACCESS SUBLIB=PRD2.TCPIP'                            00015000
         PUNCH    'CATALOG $PRECOMP.WORK REPLACE=YES'                   00016000
         END                                                            00017000
/*                                                                      00018000
// EXEC IPNETRAN,SIZE=IPNETRAN,PARM='LANG=COBOL,ENV=CICS'               00019000
 CBL XOPTS(COBOL2 CICS NOSEQ APOST)                                     00020000
       IDENTIFICATION DIVISION.                                         00021000
       PROGRAM-ID.    SERVCICS.                                         00022000
      *                                                                 00023000
      * COBOL SOCKET demonstration program                              00024000
      * CICS application - multi-tasking server                         00025000
      *                                                                 00026000
      * Requirements: This program must be defined to                   00027000
      * different CICS transaction ID's. The subtask is                 00028000
      * SOIO. The main task can be any transaction name                 00029000
      * that you want, but in this example it is 'SOCK'.                00030000
      * After it is started, it waits for a connection                  00031000
      * and it will invoke SOIO to process the request.                 00032000
      *                                                                 00033000
      * The following job will define the required                      00034000
      * entries for this test:                                          00035000
      *                                                                 00036000
      * // EXEC DFHCSDUP,SIZE=300K                                      00037000
      * DELETE GROUP(SOCKET)                                            00038000
      * DEFINE PROGRAM(SERVCICS) LANGUAGE(COBOL)   GROUP(SOCKET)        00039000
      * DEFINE TRANSACTION(SOCK) PROGRAM(SERVCICS) GROUP(SOCKET)        00040000
      * DEFINE TRANSACTION(SOIO) PROGRAM(SERVCICS) GROUP(SOCKET)        00041000
      * ADD GROUP(SOCKET) LIST(VSELIST)                                 00042000
      * /*                                                              00043000
      *                                                                 00044000
       ENVIRONMENT DIVISION.                                            00045000
       DATA DIVISION.                                                   00046000
       WORKING-STORAGE SECTION.                                         00047000
       01   MESSAGES.                                                   00048000
            05 MSG1   PIC X(41)                                         00049000
                  VALUE 'SERVCICS: Starting the server application'.    00050000
            05 MSG2   PIC X(24)                                         00051000
                  VALUE 'SERVCICS: Language=Cobol'.                     00052000
            05 MSG3   PIC X(24)                                         00053000
                  VALUE 'SERVCICS: Ready for work'.                     00054000
            05 MSG5.                                                    00055000
               10 FILLER PIC X(17)                                      00056000
                  VALUE 'SERVCICS: Socket '.                            00057000
               10 MSG5D  PIC X(4) VALUE '    '.                         00058000
               10 FILLER PIC X(7) VALUE ' Failed'.                      00059000
            05 MSG6.                                                    00060000
               10 FILLER PIC X(38)                                      00061000
                  VALUE 'SERVCICS: About to open socket (SYSID='.       00062000
               10 MSG6D  PIC X(2) VALUE '00'.                           00063000
               10 FILLER PIC X(1) VALUE ')'.                            00064000
            05 MSG8.                                                    00065000
               10 FILLER PIC X(26)                                      00066000
                  VALUE 'SERVCICS: Bytes received: '.                   00067000
               10 MSG8D  PIC 9(5) VALUE ZERO.                           00068000
            05 MSG9.                                                    00069000
               10 FILLER PIC X(35)                                      00070000
                  VALUE 'SERVCICS: Session established with '.          00071000
               10 MSG9D1 PIC 9(3).                                      00072000
               10 FILLER PIC X VALUE '.'.                               00073000
               10 MSG9D2 PIC 9(3).                                      00074000
               10 FILLER PIC X VALUE '.'.                               00075000
               10 MSG9D3 PIC 9(3).                                      00076000
               10 FILLER PIC X VALUE '.'.                               00077000
               10 MSG9D4 PIC 9(3).                                      00078000
            05 MSG10   PIC X(38)                                        00079000
               VALUE 'SERVCICS: Subtask sent back a response'.          00080000
            05 MSG11   PIC X(38)                                        00081000
               VALUE 'SERVCICS: Passing control to a subtask'.          00082000
            05 MSG12   PIC X(31)                                        00083000
               VALUE 'SERVCICS: Subtask is in control'.                 00084000
            05 MSG13   PIC X(32)                                        00085000
               VALUE 'SERVCICS: Closing the connection'.                00086000
            05 MSG14   PIC X(27)                                        00087000
               VALUE 'SERVCICS: Subtask has ended'.                     00088000
            05 MSG15   PIC X(45)                                        00089000
               VALUE 'SERVCICS: Subtask received invalid data block'.   00090000
            05 MSG16   PIC X(41)                                        00091000
               VALUE 'SERVCICS: Subtask is queuing up a RECEIVE'.       00092000
            05 MSG17   PIC X(39)                                        00093000
               VALUE 'SERVCICS: Waiting a minute for recovery'.         00094000
            05 MSG18.                                                   00095000
               10 FILLER   PIC X(32)                                    00096000
                  VALUE 'SERVCICS: Error occurred during '.             00097000
               10 MSG18D1  PIC X(12) VALUE SPACES.                      00098000
               10 FILLER   PIC X(8)                                     00099000
                  VALUE 'Problem='.                                     00100000
               10 MSG18D2  PIC X(12) VALUE SPACES.                      00101000
            05 MSG19.                                                   00102000
               10 FILLER   PIC X(31)                                    00103000
                  VALUE 'SERVCICS: Bad length received: '.              00104000
               10 MSG19D   PIC 9(5).                                    00105000
                                                                        00106000
       01   WORK-AREAS.                                                 00107000
            05  HALFWORD       PIC 9(4) COMP.                           00108000
            05  HALFWORD-X REDEFINES HALFWORD.                          00109000
               10 BYTE1        PIC X(1).                                00110000
               10 BYTE2X       PIC X(1).                                00111000
                                                                        00112000
            05  SOCK-LENG      PIC 9(8) COMP.                           00113000
            05  DESC           PIC X(4).                                00114000
            05  RESULTS.                                                00115000
                10 RECB        PIC X(4).                                00116000
                10 RLOPORT     PIC 9(4) COMP.                           00117000
                10 RFOPORT     PIC 9(4) COMP.                           00118000
                10 RFOIP.                                               00119000
                   15 IPAD1    PIC X.                                   00120000
                   15 IPAD2    PIC X.                                   00121000
                   15 IPAD3    PIC X.                                   00122000
                   15 IPAD4    PIC X.                                   00123000
                10 RCOUNT      PIC 9(4) COMP.                           00124000
                10 RFLAGS      PIC X.                                   00125000
                10 RCODE       PIC X.                                   00126000
                10 RTERMTY     PIC X(40).                               00127000
            05  BUFFER          PIC X(1024).                            00128000
                                                                        00129000
       LINKAGE SECTION.                                                 00130000
       01  LOW-STORAGE.                                                 00131000
           05  FILLER         PIC X(20).                                00132000
           05  COMREG-POINTER USAGE IS POINTER.                         00133000
                                                                        00134000
       01  COMREG.                                                      00135000
           05  FILLER         PIC X(112).                               00136000
           05  SYSPARM-POINTER USAGE IS POINTER.                        00137000
                                                                        00138000
       01  SYSPARM.                                                     00139000
           05 SYSPARM-LENGTH  PIC X.                                    00140000
           05 SYSPARM-VALUE   PIC X(2).                                 00141000
                                                                        00142000
       PROCEDURE DIVISION.                                              00143000
           EXEC TCP CONTROL DOUBLE(NO)                                  00144000
           END-EXEC.                                                    00145000
           EXEC CICS HANDLE CONDITION                                   00146000
                     IOERR     (IOERR)                                  00147000
                     INVREQ    (INVREQ)                                 00148000
                     TRANSIDERR(TRANSIDERR)                             00149000
                     LENGERR   (LENGERR)                                00150000
                     NOTAUTH   (NOTAUTH)                                00151000
                     ERROR     (GENERROR)                               00152000
           END-EXEC.                                                    00153000
           IF EIBTRNID NOT = 'SOIO' GO TO MAIN-TASK.                    00154000
      * --------------------------------------------------- *           00155000
      *                                                     *           00156000
      *            SUBTASK PROCESSING GOES IN HERE!         *           00157000
      *                                                     *           00158000
      * --------------------------------------------------- *           00159000

           EXEC CICS HANDLE ABEND LABEL(CLOSE-SOCKET)
           END-EXEC.
           EXEC CICS WRITE OPERATOR TEXT(MSG12) TEXTLENGTH(31)          00160000
           END-EXEC.                                                    00161000
      *-----------------------------------------------------*           00162000
      *                                                     *           00163000
      * This area will accept the descriptor, receiove some *           00164000
      * data, acknowledge it, do some task, end quit.       *           00165000
      *                                                     *           00166000
      *-----------------------------------------------------*           00167000
           MOVE LENGTH OF XOBLOK-AREA TO HALFWORD.                      00168000
           EXEC CICS RETRIEVE INTO(XOBLOK-AREA) LENGTH(HALFWORD)        00169000
           END-EXEC.                                                    00170000
           MOVE XODESC TO DESC.                                         00171000
      *-----------------------------------------------------*           00172000
      *                                                     *           00173000
      *  Indicate that it's ok, and receive some data       *           00174000
      *                                                     *           00175000
      *-----------------------------------------------------*           00176000
           EXEC CICS WRITE OPERATOR TEXT(MSG16) TEXTLENGTH(41)          00177000
           END-EXEC.                                                    00178000
           MOVE 1024 TO SOCK-LENG.                                      00179000
           EXEC TELNET RECEIVE                                          00180000
                     TO(BUFFER)                                         00181000
                     LENGTH(SOCK-LENG)                                  00182000
                     RESULTAREA(RESULTS)                                00183000
                     WAIT(YES)                                          00184000
                     DESCRIPTOR(DESC)                                   00185000
                     ERROR(RECEIVE-FAILED)                              00186000
           END-EXEC.                                                    00187000
           MOVE RCOUNT TO MSG8D.                                        00188000
           EXEC CICS WRITE OPERATOR TEXT(MSG8) TEXTLENGTH(31)           00189000
           END-EXEC.                                                    00190000
      *-----------------------------------------------------*           00191000
      *                                                     *           00192000
      *  Typically, this is where you would actually add    *           00193000
      *  your internal processing logic, such as updating   *           00194000
      *  a file or some such thing.                         *           00195000
      *                                                     *           00196000
      *-----------------------------------------------------*           00197000
                                                                        00198000
      * < -------------- ADD STUFF HERE ------------------<<<           00199000
                                                                        00200000
      *-----------------------------------------------------*           00201000
      *                                                     *           00202000
      *  Now that processing is done, send back a response. *           00203000
      *                                                     *           00204000
      *-----------------------------------------------------*           00205000
           MOVE 'GOOD' TO BUFFER.                                       00206000
           MOVE 4 TO SOCK-LENG.                                         00207000
           EXEC TELNET SEND                                             00208000
                     FROM(BUFFER)                                       00209000
                     DESCRIPTOR(DESC)                                   00210000
                     LENGTH(SOCK-LENG)                                  00211000
                     RESULTAREA(RESULTS)                                00212000
                     WAIT(YES)                                          00213000
                     ERROR(SEND-FAILED)                                 00214000
           END-EXEC.                                                    00215000
           EXEC CICS WRITE OPERATOR TEXT(MSG10) TEXTLENGTH(38)          00216000
           END-EXEC.                                                    00217000
      *-----------------------------------------------------*           00218000
      *                                                     *           00219000
      *  Close the socket connection and get out.           *           00220000
      *                                                     *           00221000
      *-----------------------------------------------------*           00222000
       CLOSE-SOCKET.                                                    00223000

           EXEC CICS HANDLE ABEND CANCEL
           END-EXEC.
           EXEC CICS WRITE OPERATOR TEXT(MSG13) TEXTLENGTH(32)          00224000
           END-EXEC.                                                    00225000
           EXEC TELNET CLOSE                                            00226000
                     RESULTAREA(RESULTS)                                00227000
                     DESCRIPTOR(DESC)                                   00228000
                     WAIT(YES)                                          00229000
                     ERROR(CLOSEOUT)                                    00230000
           END-EXEC.                                                    00231000
       CLOSEOUT.                                                        00232000
           EXEC CICS WRITE OPERATOR TEXT(MSG14) TEXTLENGTH(27)          00233000
           END-EXEC.                                                    00234000
           GO TO EXIT-PROGRAM.                                          00235000
      *-----------------------------------------------------*           00236000
      *                                                     *           00237000
      *  If there were any problems, tell us about them!    *           00238000
      *                                                     *           00239000
      *-----------------------------------------------------*           00240000
       SEND-FAILED.                                                     00241000
           MOVE 'SEND' TO MSG5D.                                        00242000
           GO TO TELL-ABOUT-FAILURE.                                    00243000
       RECEIVE-FAILED.                                                  00244000
           MOVE 'RECV' TO MSG5D.                                        00245000
       TELL-ABOUT-FAILURE.                                              00246000
           EXEC CICS WRITE OPERATOR TEXT(MSG5) TEXTLENGTH(28)           00247000
           END-EXEC.                                                    00248000
           GO TO CLOSE-SOCKET.                                          00249000
      * --------------------------------------------------- *           00250000
      *                                                     *           00251000
      *          MAIN TASK PROCESSING GOES IN HERE!         *           00252000
      *                                                     *           00253000
      * --------------------------------------------------- *           00254000
       MAIN-TASK.                                                       00255000

           EXEC CICS HANDLE ABEND LABEL(CLOSE-SOCKET)
           END-EXEC.
           EXEC CICS WRITE OPERATOR TEXT(MSG1) TEXTLENGTH(41)           00256000
           END-EXEC.                                                    00257000
           EXEC CICS WRITE OPERATOR TEXT(MSG2) TEXTLENGTH(24)           00258000
           END-EXEC.                                                    00259000
      *-----------------------------------------------------*           00260000
      *                                                     *           00261000
      *  Allow SYSID to be overridden via // OPTION SYSPARM *           00262000
      *                                                     *           00263000
      *-----------------------------------------------------*           00264000
           SET ADDRESS OF COMREG TO COMREG-POINTER.                     00265000
           SET ADDRESS OF SYSPARM TO SYSPARM-POINTER.                   00266000
           IF SYSPARM-LENGTH EQUAL X'02'                                00267000
               MOVE SYSPARM-VALUE TO MSG6D.                             00268000
       SOCKET-OPEN.                                                     00269000
           EXEC CICS WRITE OPERATOR TEXT(MSG6) TEXTLENGTH(41)           00270000
           END-EXEC.                                                    00271000
           EXEC CICS WRITE OPERATOR TEXT(MSG3) TEXTLENGTH(24)           00272000
           END-EXEC.                                                    00273000
           EXEC TELNET OPEN LOCALPORT(6666)                             00274000
                         FOREIGNIP(0)                                   00275000
                         FOREIGNPORT(0)                                 00276000
                         DESCRIPTOR(DESC)                               00277000
                         PASSIVE(YES)                                   00278000
                         RESULTAREA(RESULTS)                            00279000
                         WAIT(YES)                                      00280000
                         ERROR(OPEN-FAILURE)                            00281000
           END-EXEC.                                                    00282000
      *-----------------------------------------------------*           00283000
      *                                                     *           00284000
      *  We are now connected. Get the Foreign IP address   *           00285000
      *  and tell the operator that we're in business.      *           00286000
      *                                                     *           00287000
      * --------------------------------------------------- *           00288000
           MOVE ZERO TO HALFWORD.                                       00289000
           MOVE IPAD1 TO BYTE2X.                                        00290000
           MOVE HALFWORD TO MSG9D1.                                     00291000
           MOVE IPAD2 TO BYTE2X.                                        00292000
           MOVE HALFWORD TO MSG9D2.                                     00293000
           MOVE IPAD3 TO BYTE2X.                                        00294000
           MOVE HALFWORD TO MSG9D3.                                     00295000
           MOVE IPAD4 TO BYTE2X.                                        00296000
           MOVE HALFWORD TO MSG9D4.                                     00297000
           EXEC CICS WRITE OPERATOR TEXT(MSG9) TEXTLENGTH(50)           00298000
           END-EXEC.                                                    00299000
      *-----------------------------------------------------*           00300000
      *                                                     *           00301000
      *  Start a subtask and pass the socket descriptor.    *           00302000
      *                                                     *           00303000
      * --------------------------------------------------- *           00304000
           EXEC CICS WRITE OPERATOR TEXT(MSG11) TEXTLENGTH(38)          00305000
           END-EXEC.                                                    00306000
           MOVE LENGTH OF XOBLOK-AREA TO HALFWORD.                      00307000
           MOVE HALFWORD TO MSG19D.                                     00308000
           MOVE 'START-TASK' TO MSG18D1.                                00309000
           EXEC CICS START INTERVAL(0) TRANSID('SOIO')                  00310000
                  FROM(XOBLOK-AREA) LENGTH(HALFWORD)                    00311000
           END-EXEC.                                                    00312000
           GO TO SOCKET-OPEN.                                           00313000
      *-----------------------------------------------------*           00314000
      *                                                     *           00315000
      *  In case of a problem, recover from a bad OPEN.     *           00316000
      *                                                     *           00317000
      * --------------------------------------------------- *           00318000
       OPEN-FAILURE.                                                    00319000
           MOVE 'OPEN' TO MSG5D.                                        00320000
           EXEC CICS WRITE OPERATOR TEXT(MSG5) TEXTLENGTH(28)           00321000
           END-EXEC.                                                    00322000
           EXEC CICS WRITE OPERATOR TEXT(MSG13) TEXTLENGTH(32)          00323000
           END-EXEC.                                                    00324000
           EXEC TELNET CLOSE                                            00325000
                     RESULTAREA(RESULTS)                                00326000
                     WAIT(YES)                                          00327000
                     DESCRIPTOR(DESC)                                   00328000
                     ERROR(WAIT-A-MINUTE)                               00329000
           END-EXEC.                                                    00330000
       WAIT-A-MINUTE.                                                   00331000
           EXEC CICS WRITE OPERATOR TEXT(MSG17) TEXTLENGTH(39)          00332000
           END-EXEC.                                                    00333000
           EXEC CICS DELAY FOR SECONDS(60)                              00334000
           END-EXEC.                                                    00335000
           GO TO SOCKET-OPEN.                                           00336000
                                                                        00337000
      *-----------------------------------------------------*           00338000
      *                                                     *           00339000
      *  Display the problem before exiting                 *           00340000
      *                                                     *           00341000
      * --------------------------------------------------- *           00342000
       LENGERR.                                                         00343000
           EXEC CICS WRITE OPERATOR TEXT(MSG19) TEXTLENGTH(36)          00344000
           END-EXEC.                                                    00345000
           MOVE 'LENGTHERROR' TO MSG18D2.                               00346000
           GO TO TELL-ERROR.                                            00347000
       NOTAUTH.                                                         00348000
           MOVE 'NOTAUTH' TO MSG18D2.                                   00349000
           GO TO TELL-ERROR.                                            00350000
       GENERROR.                                                        00351000
           MOVE 'GENERIC-ERR' TO MSG18D2.                               00352000
           GO TO TELL-ERROR.                                            00353000
       INVREQ.                                                          00354000
           MOVE 'INVREQ' TO MSG18D2.                                    00355000
           GO TO TELL-ERROR.                                            00356000
       IOERR.                                                           00357000
           MOVE 'IOERR' TO MSG18D2.                                     00358000
           GO TO TELL-ERROR.                                            00359000
       TRANSIDERR.                                                      00360000
           MOVE 'TRANSIDERR' TO MSG18D2.                                00361000
           GO TO TELL-ERROR.                                            00362000
       TELL-ERROR.                                                      00363000
           EXEC CICS WRITE OPERATOR TEXT(MSG18) TEXTLENGTH(64)          00364000
           END-EXEC.                                                    00365000
                                                                        00366000
      *-----------------------------------------------------*           00367000
      *                                                     *           00368000
      *  Terminate this task (SOCK or SOIO)                 *           00369000
      *                                                     *           00370000
      * --------------------------------------------------- *           00371000
       EXIT-PROGRAM.                                                    00372000
           EXEC CICS RETURN                                             00373000
           END-EXEC.                                                    00374000
/*                                                                      00375000
/*                                                                      00376000
// OPTION DECK                                                          00377000
// EXEC ASSEMBLY                                                        00378000
         PUNCH    '/+'                                                  00379000
         PUNCH    '/*'                                                  00380000
         PUNCH    '/&&'                                                 00381000
         PUNCH    '* $$ EOJ'                                            00382000
         END                                                            00383000
/*                                                                      00384000
/&                                                                      00385000
* $$ EOJ                                                                00386000
